<template>
  <div class="container mx-auto uc-section overflow-hidden my-10 use-new-color-config">
    <div class="uc-section-title-container">
      <div class="uc-section-title">
        <h3>{{ $t("user_center") }} / {{ title === $t('deposit') ? $t(`deposit${isBhinbhin}`) : title }}</h3>
      </div>
    </div>
    <div class="flex w-full uc-section-content">
      <div
        class="uc-section-left flex flex-col items-center justify-between min-w-[200px]"
      >
        <div class="uc-tab-container flex flex-col">
          <template v-for="tab in userCenterTabs" :key="tab.to">
            <nuxt-link
              v-if="tab.display"
              :id="`uc${upperFirst(camelCase(tab.label))}Tab`"
              :to="tab.to"
              class="uc-tab"
              :class="{ selected: checkActiveLink(tab.to) }"
            >
              <SvgIcon :svg-name="tab.icon" style="width: 24px; height: 24px; pointer-events: none;" />
              <span class = "pointer-events-none">{{ tab.label === 'deposit' ? $t(`deposit${isBhinbhin}`) : $t(tab.label) }}</span>
              <MessagesMessageCount
                v-if="unreadInfo && unreadInfo.TotalCount && tab.label === 'messages'"
                :count="unreadInfo.TotalCount"
                :is-unread="true"
                class="!ml-0"
              ></MessagesMessageCount>
            </nuxt-link>
          </template>
        </div>
        <div
          class="logout-section w-full flex flex-col justify-center p-4 min-h-[82px]"
        >
          <div v-if="allowLogout" class="divider"></div>
          <el-button
            v-if="allowLogout"
            class="logout-btn px-4 py-1 text-sm w-full rounded btn bg-secondary"
            :disabled="isLoading"
            :loading="isLoading"
            @click="logout"
            >{{ $t("logout") }}</el-button
          >
        </div>
      </div>
      <div
        class="uc-section-right w-full ol-bg-light"
        style="max-width: calc(100% - 200px)"
      >
        <div :class="['flex-auto h-full']" class="user-center">
          <slot />
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { PropType } from "vue";
import { camelCase, upperFirst } from "lodash-es";
import useMenu from "@/composables/useMenu";
import { store } from "~/store";
import commonHelper from "@/utils/commonHelper";

interface IUserCenterTab {
  to: string;
  label: string;
  icon: string;
  display: boolean;
}
const props = defineProps({
  title: {
    type: String,
    default: "",
  },
  tabs: {
    type: Object as PropType<IUserCenterTab[]>,
    default: [],
  },
  allowLogout: {
    type: Boolean,
    default: true,
  },
});

const emit = defineEmits(["routerClicked"]);
const {
  isCashPlayer,
  isShowDepositWithdrawal,
  isShowPromotion,
  isShowReferral,
} = useMenu();

const { logout, isLoading, isReferralV2Enabled } = useHeaderComponent();
const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
const tabs = reactive([
  {
    to: "/deposit",
    label: "deposit",
    icon: "icon-deposit",
    display: isCashPlayer.value && isShowDepositWithdrawal.value,
  },
  {
    to: "/withdrawal",
    label: "withdrawal",
    icon: "icon-withdraw",
    display: isCashPlayer.value && isShowDepositWithdrawal.value,
  },
  { to: "/wallet", label: "wallet", icon: "icon-wallet", display: true },
  { to: "/account", label: "account", icon: "icon-account", display: true },
  {
    to: "/transaction-history",
    label: "statement",
    icon: "icon-transaction",
    display: true,
  },
  {
    to: "/bet-history",
    label: "bet_history",
    icon: "icon-bethistory",
    display: true,
  },
  {
    to: "/my-promotion",
    label: "promotion",
    icon: "icon-promotion",
    display: isShowPromotion.value,
  },
  {
    to: "/referral",
    label: "referral",
    icon: "icon-referral",
    display:
      isCashPlayer.value &&
      isShowReferral.value &&
      !isReferralV2Enabled.value &&
      isShowReferralPage.value,
  },
  {
    to: "/referral-v2",
    label: "referral",
    icon: "icon-referral",
    display: isReferralV2Enabled.value && isShowReferralPage.value,
  },
  {
    to: "/messages",
    label: "messages",
    icon: "message",
    display: true,
  },
]).filter((p) => p.display);

const { fetchMessages, unreadInfo } = useMessage();

const userCenterTabs = computed(() => {
  props.tabs
    .filter((tab: any) => tab.label.includes("referral"))
    .map(
      (tab: any) =>
        (tab.display = isReferralV2Enabled.value && isShowReferralPage.value)
    );
  if (props.tabs && props.tabs.length > 0) return props.tabs;
  return tabs;
});
const route = useRoute();

onMounted(() => {
  if (!route.fullPath.includes("messages")) {
    fetchMessages();
  }
});
const checkActiveLink = (link: string) => {
  const currentPath = route.fullPath.includes("/uc=")
    ? String(route.query.uc)
    : route.fullPath;
  if (currentPath.startsWith(link)) {
    const activeTab = userCenterTabs.value.find(
      (tab: IUserCenterTab) => tab.to === link
    );
    if (activeTab) {
      emit("routerClicked", activeTab);
    }
  }
  const isOldReferral =
    link.includes("/referral") && !link.includes("/referral-v2");
  if (isOldReferral && currentPath.includes("/referral-v2")) {
    return false;
  }
  return currentPath.startsWith(link);
};
const isBK8 = computed(() => {
  if (store.state.selectedThemeName === "bk8") {
    return true;
  } else {
    return false;
  }
});
const { isBhinbhin } = commonHelper;
</script>
<style>
.uc-section .el-loading-mask {
  background: transparent;
}
.uc-section .el-table__empty-block {
  height: auto !important;
  border: var(--el-table-border);
  border-top: unset;
  border-bottom-left-radius: 8px;
  border-bottom-right-radius: 8px;
}

.uc-section .el-table {
  --el-table-border: 2px solid var(--el-table-border-color);
  border-radius: 8px;
}
.uc-section .el-table--border .el-table__inner-wrapper tr td:first-child {
  border-left: var(--el-table-border);
}
.uc-section .el-table tr th.is-center.el-table__cell {
  border-top: var(--el-table-border);
}
.uc-section .el-table__border-left-patch,
.uc-section .el-table--border::before,
.uc-section .el-table__inner-wrapper::before,
.uc-section .el-table--border .el-table__inner-wrapper::after,
.uc-section .el-table--border::after {
  width: 0;
}
.uc-section tr:first-child th:first-child {
  border-top-left-radius: 8px;
}
.uc-section tr:first-child th:last-child {
  border-top-right-radius: 8px;
}
.uc-section thead tr:not(:first-child) th {
  border-top: unset !important;
}
.uc-section:not(.bet-history) tr:last-child td:first-child {
  border-bottom-left-radius: 8px;
}
.uc-section:not(.bet-history) tr:last-child td:last-child {
  border-bottom-right-radius: 8px;
}
.uc-section:not(.bet-history-page) tr:last-child td:first-child {
  border-bottom-left-radius: 8px;
}
.uc-section:not(.bet-history-page) tr:last-child td:last-child {
  border-bottom-right-radius: 8px;
}
.uc-section.bet-history .el-table__inner-wrapper {
  padding-bottom: 15px;
}
[theme-color="sbo"] .uc-section {
  margin-top: 2.5rem !important;
}
</style>
<style scoped lang="scss">
.uc-section,
.uc-section :deep(.el-radio__label),
.uc-section :deep(.time-notice-footer),
.uc-section :deep(.fc-text) {
  color: var(--text5);
  font-weight: 500;
}
.uc-section :deep(.el-radio:not(:last-child)) {
  margin-right: 16px;
}
.uc-section :deep(.el-button svg) {
  fill: var(--textBtn);
  stroke: var(--textBtn);
  width: 16px;
  height: 16px;
}
.uc-section-left .uc-tab,
.uc-section-left .logout-section {
  // max-width: 84%;
  width: 100%;
}
.uc-section-left .logout-section .divider {
  height: 2px;
  background-color: var(--border);
  margin-bottom: 18px;
}

.uc-section-left .logout-section .logout-btn {
  color: var(--textBtn);
  border-radius: 8px;
  background: var(--secondary);
}
// .uc-section-left {
//   padding-top: 1rem;
// }
.uc-section-right {
  --bg-base-color: var(--background5);
  --bg-opacity: 0.05;
}
.uc-section-left,
.uc-section-title-container {
  background: var(--background5);
}
:deep(.uc-section-right .el-scrollbar__view) {
  height: 100%;
}
.uc-section-title {
  padding: 1rem 34px;
  border-bottom: solid 2px var(--border);
  height: 64px;
}
.uc-section-title h3 {
  text-transform: capitalize;
  color: var(--primary);
  font-style: normal;
  font-weight: 600;
  font-size: 24px;
  line-height: 28px;
}
.uc-section {
  border-radius: 16px;
  // height: 786px;
  display: flex;
  flex-direction: column;
}
.uc-section-content {
  max-height: calc(100% - 62px); // title height
  height: 100%;
}
.uc-tab-container {
  display: flex;
  flex-direction: column;
  gap: 0.5rem;
  width: 200px;
  align-items: center;
  padding: 1rem;
}
.uc-tab {
  position: relative;
  display: flex;
  gap: 0.625rem;
  padding: 0.75rem 1rem;
  border-radius: 8px;
  align-items: center;
  position: relative;
  font-weight: 500;
}
.uc-tab svg,
.uc-tab span {
  color: var(--text5);
  fill: var(--text5);
  opacity: 0.5;
}
.uc-tab.selected svg,
.uc-tab.selected span {
  color: var(--textBtn);
  fill: var(--textBtn);
  opacity: 1;
}
.uc-tab.selected {
  background: var(--primary);
  color: var(--textBtn);
}
.uc-tab:hover:not(.selected)::before {
  // background
  content: "";
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  background: var(--primary);
  opacity: 0.2;
  border-radius: 8px;
}

.uc-tab.selected::after {
  // the left pill of the tab
  content: "";
  position: absolute;
  border-radius: 1px;
  width: 2px;
  height: 8px;
  background-color: var(--textBtn);
  left: 0.5rem;
  top: 50%;
  transform: translateY(-50%);
}

.uc-tab svg {
  height: 1.5rem;
  width: 1.5rem;
  object-fit: contain;
}
.uc-tab.selected svg {
  fill: var(--textBtn);
}
.uc-tab:hover svg {
  // fill: var(--textBtn);
}

.uc-section :deep(.el-table) {
  --el-table-bg-color: var(--background5);
  --el-table-tr-bg-color: var(--el-table-bg-color);
}
.uc-section :deep(.el-tabs__item) {
  height: 58px;
  line-height: 58px;
  color: var(--text5);
}
.uc-section :deep(.el-tabs__item:not(.is-active)) {
  color: var(--text5);
}
.uc-section :deep(.el-input) {
  background-color: var(--background5);
  --el-input-text-color: var(--text5);
  border-radius: 8px;
}

.user-center :deep(.el-overlay){
  background-color: rgba(0, 0, 0, 0.5);
}
.uc-section :deep(.el-tabs__item.is-active) {
  color: var(--primary);
}
</style>

<style lang="scss">
.bet-history-table-container,
.game-bet-history-table-container {
  height: 100% !important;
  .sport-bet-table,
  .game-bet-table {
    height: 100%;
    .el-table {
      height: 100%;
    }
    .el-table__body-wrapper {
      height: calc(100% - 35px);
      padding-bottom: 0 !important;
    }
    .el-table__inner-wrapper {
      padding-bottom: 0 !important;
      max-height: 510px;
      height: 100%;
      // overflow: auto;
    }
    .el-table__empty-block {
      height: 100% !important;
    }
  }
}
.winlose-desktop,
.withdrawal-desktop,
.desktop-transaction-deposit {
  height: 100% !important;
  .el-table__body-wrapper {
    height: 100% !important;
    padding-bottom: 0 !important;
  }
  .el-table__inner-wrapper {
    padding-bottom: 0 !important;
    height: fit-content !important;
    max-height: 510px;
    overflow-y: auto !important;
  }
}
</style>
